#ifndef __gtkhistogram_protected__
#define __gtkhistogram_protected__

struct _Canvas {
    int ch,cw,width,height;
    int sch,scw;
    int wx,wy,wz;
    int ox,oy,oz;
    int px0,px1;
    int py0,py1;
    int pz0,pz1;
    cairo_surface_t *surface;
    cairo_t *cairo;
    GMutex *mutex;
    GdkRectangle cscale;
    char *text_font;
    char *axis_font;
    double line_width;

    gboolean   fixed;
    double xmin,xmax;
    double ymin,ymax;
    double zmin,zmax;
    double xstp,ystp,zstp;
    double sx, sy,sz,  ex, ey, ez;
    gboolean   logx,logy;
    double lxmin,lymin;
    GList  *curve_colors;
    PangoLayout *legend;
    int     leg_x,leg_y;
    
    gchar *color_names[HST_NCOLORS];

    /*
     * Stats for a range
     */
    HstStats *stats;
};

/*< private >*/
void canvas_set(GtkHst1D *);
/*< private >*/
void canvas_transform(Canvas *,double, double , HstPoint *);
/*< private >*/
void canvas_transform_inv(Canvas *,int ix, int iy, double *x, double *y);
/*< private >*/
HstPoint * canvas_transform_tuple(Canvas *, HstTuple *);


#endif
