#include <stdio.h>
#include <math.h>
#include <gtk/gtk.h>

#include <gtk-hst/gtkgauge.h>
#include "random.h"

GtkWidget *create_mainWindow (void);

GPrintFunc std_logger;
void my_logger(const gchar *string) {
    printf("[mylogger]%s\n",string);
}


gboolean
idle_func (GtkWidget *mainW)
{
    GObject *O = G_OBJECT(mainW);
    GtkGauge *gauge= GTK_GAUGE( g_object_get_data(O,"gauge" ));
    if (gauge)
    {
        double val = randgauss(22.e3, 1.e3); //25.0 + 0.01 * randuniform();
        gtk_gauge_set_value(gauge, val);
    }
    
    return TRUE;
}


static gboolean 
delete_event( GtkWidget *widget,
              GdkEvent  *event,
              gpointer   data )
{
    /* Do not destroy with a delete-event */
    return TRUE;
}

int main (int argc, char *argv[]) {
  GtkWidget *mainWindow;
  int iid;

  //std_logger = g_set_printerr_handler( my_logger );
  
  gtk_init (&argc, &argv);
  
  mainWindow = create_mainWindow ();

  iid = g_timeout_add(500, (GSourceFunc)idle_func, mainWindow);
  printf ("idle id: %d\n", iid);
  gtk_dialog_run(GTK_DIALOG(mainWindow));
  return 0;
}

GtkWidget *
create_mainWindow (void)
{
    GtkWidget *mainWindow;
    GtkWidget *gauge;
    
    mainWindow = gtk_dialog_new_with_buttons(
                         "H1D", NULL,
					     GTK_DIALOG_MODAL| GTK_DIALOG_DESTROY_WITH_PARENT,
					     GTK_STOCK_OK,
					     GTK_RESPONSE_ACCEPT,
					     NULL
	);

    gauge = gtk_gauge_new(0., 50.e3);
    gtk_gauge_set_title(GTK_GAUGE(gauge), "Gauge Example");
    g_object_set_data( G_OBJECT(mainWindow),"gauge", gauge);
    
    gtk_container_add (GTK_CONTAINER (  gtk_dialog_get_content_area( GTK_DIALOG(mainWindow) )), gauge);

    gtk_widget_show_all(mainWindow);

    return mainWindow;
}
