/*
 * test_profile.c
 *
 *  Created on: Jan 21, 2015
 *      Author: lacasta
 */

#include <stdio.h>
#include "random.h"
#include "gtk-hst/profile.h"


int main(int argc, char **argv)
{
    int ievt, ibin, irms, nc;
    double rms[]={ 1, 2, 3, 4};
    const int nrms = sizeof(rms)/sizeof(double);
    const int nbin = 4;
    const int ntot = nbin*nrms;
    double *stdv = 0;
    HstProfile *profile;

    profile = hst_profile_new(ntot, 0.0, ntot, 0);

    for (ibin=0; ibin<ntot; ibin++)
    {
        irms = ibin/nbin;
        for ( ievt = 0; ievt<10000; ievt++)
        {
            double val = randgauss(0, rms[irms]);
            hst_profile_fill(profile, ibin, val, 1.0);
        }
    }

    g_object_get(G_OBJECT(profile), "rms", &stdv, "nx", &nc, NULL);

    for (ibin=0; ibin<nc; ibin++)
    {
        irms = ibin/nbin;
        printf("%3d %.2f [%.2f]\n", ibin, stdv[ibin], rms[irms]);
    }

    g_free(stdv);
}
