/*
 * tstCairo.c
 *
 *  Created on: Jan 21, 2015
 *      Author: lacasta
 */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gtk-hst/tracer.h>
#include <gtk-hst/gtkhistogram.h>
#include "random.h"


HstTracer *tracer_1=0;
HstTracer *tracer_2=0;

gboolean
idle_func (gpointer ptr)
{
    double val = randgauss(0.0, 8.0);
    hst_histogram_fill(HST_HISTOGRAM(tracer_1), val, 1.0);

    val = randgauss(5.0, 2.5);
    hst_histogram_fill(HST_HISTOGRAM(tracer_2), val, 1.0);
    return TRUE;
}


GtkWidget *create_mainWindow()
{
    GtkWidget *mainWindow;
    GtkWidget *notebook;
    GtkWidget *hbox;
    GtkWidget *label;
    GtkWidget *hst;
    HstHistogram *hf;
    mainWindow = gtk_dialog_new_with_buttons(
                             "DebugCairo", NULL,
                             GTK_DIALOG_MODAL| GTK_DIALOG_DESTROY_WITH_PARENT,
                             GTK_STOCK_OK,
                             GTK_RESPONSE_ACCEPT,
                             NULL
        );

    notebook = gtk_notebook_new();
    hbox = gtk_hbox_new(TRUE, 0);


    gtk_box_pack_start(GTK_BOX(hbox), gtk_label_new("A label"), FALSE, FALSE, 0);
    label = gtk_label_new("tab 1");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), hbox, label);



    hbox = gtk_hbox_new(TRUE, 0);
    tracer_1 = hst_tracer_new(50);
    hst = gtk_hst1d_new(HST_FUNCTION(tracer_1));
    gtk_hst1d_monitor_start(GTK_HST1D(hst),500);
    gtk_box_pack_start(GTK_BOX(hbox), hst, FALSE, FALSE, 0);

    tracer_2 = hst_tracer_new(50);
    hst = gtk_hst1d_new(HST_FUNCTION(tracer_2));
    gtk_hst1d_monitor_start(GTK_HST1D(hst),500);
    gtk_box_pack_start(GTK_BOX(hbox), hst, FALSE, FALSE, 0);

    g_idle_add( (GSourceFunc)idle_func, hf);


    label = gtk_label_new("tab 2");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), hbox, label);


    gtk_container_add (GTK_CONTAINER (  gtk_dialog_get_content_area( GTK_DIALOG(mainWindow) )), notebook);

    gtk_widget_show_all(mainWindow);
    g_object_set_data(G_OBJECT(mainWindow), "hst", hst);

    return mainWindow;
}

int main(int argc, char **argv)
{
    GtkWidget *mainWindow;
    gtk_init (&argc, &argv);

    mainWindow = create_mainWindow ();

    gtk_dialog_run(GTK_DIALOG(mainWindow));
    return 0;
}




